%define rel 3

Name: open-xchange
Version: 0.8.0
Release: alt1.%rel

Summary: OPEN-XCHANGE - The Collaboration and Integration Environment
License: GPL
Group: Development/Java

Source: %name-%version-%rel.tar.bz2
Source1: %name-apache.conf
Source2: %name.init
Source3: openexchange-groupware.in
Source4: openexchange-sessiond.in
Source5: openexchange-webmail.in
Source6: %name-servlet.xml
Source7: ox_zenith_iconset-0.1.tar.gz
Source8: %name-umin.xml
Source9: %name-tomcat4-servlet.xml
Source10: %name-tomcat4-umin.xml
Source11: %name-QUICK-START
# RU translation. Translated by Alex <exilit at nm.ru>
Source12: ott_groupware_%version-%rel.tar.bz2
Source13: ott_webmail_%version-%rel.tar.bz2
Patch: %name-Makefile.patch
Patch1: %name-fix-perl.patch
Patch2: %name-init_ldap.patch
Patch3: %name-oxumin.patch
Requires: java-common
BuildPreReq: /proc rpm-build-java openldap-clients

%def_disable ssl
%define pgjdbc %_javadir/postgresql74-jdbc/pg74-jdbc3.jar

%if_disabled ssl
BuildArch: noarch
%endif

BuildRequires: ant ant-optional antlr bcel jaf jai jakarta-commons-logging jakarta-commons-net jakarta-oro
BuildRequires: jakarta-regexp javamail jdepend jdom jsch junit log4j servletapi5 stylebook xalan-j xerces-j
BuildRequires: xml-commons-apis postgresql74-jdbc sudo gcc-c++

%description
OPEN-XCHANGE is a collaboration and integration server environment
with a continuous right management for modules and objects.
The product is based on existing components like a web server,
mail server, directory server, database ...

There are several interfaces (like WebDAV/XML interfaces)
coming along with this software.

OPEN-XCHANGE provides the following modules:
 - portal
 - calendar
 - contacts
 - addresses
 - tasks
 - projects
 - documents
 - knowledge
 - bookmarks
 - pinbord
 - forums
 - webmailer

OPEN-XCHANGE is JAVA(tm) based with some pieces of C for security
components.

%package server
Group: System/Servers
Summary: %name server
Requires: %name = %version-%release
Requires: openldap-servers openldap-clients postgresql74-jdbc
Requires: perl-CGI perl-IO-Socket-SSL perl-Net-SSLeay perl-Storable perl-URI
AutoReq: yes, noperl

%description server
%name server.

%package javadoc
Group: Development/Java
Summary: Javadoc for %name
Requires: java-common

%description javadoc
Javadoc for %name.

%package webapp-tomcat4
Group: Networking/WWW
Summary: %name webapp for tomcat4
Requires: tomcat4-server
Requires: %name-server = %version-%release

%description webapp-tomcat4
%summary

%package webapp-tomcat5
Group: Networking/WWW
Summary: %name webapp for tomcat5
Requires: tomcat5-server
Requires: %name-server = %version-%release

%description webapp-tomcat5
%summary

%package apache
Group: System/Configuration/Other
Summary: %name configuration file for apache 1.3
Requires: apache mod_jk
Requires: %name-server = %version-%release

%description apache
%summary

%package apache2
Group: System/Configuration/Other
Summary: %name configuration file for apache 2.x
Requires: apache2 apache2-mod_jk
Requires: %name-server = %version-%release

%description apache2
%summary

%prep
%setup -q -n %name-%version-%rel
%patch -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0

# fixed in 8.0
#%__subst "s|cp -c src/misc/ssl/liboxssl.la |cp src/misc/ssl/liboxssl.la \${DESTDIR}|" Makefile.in
# move tmpdir in a safe place
%__subst "s|temporary_ldap_scripts.ldif|tmp/temporary_ldap_scripts.ldif|" conf/admintools.conf.in
%__subst "s|/tmp/|%_localstatedir/%name/tmp/|" conf/groupware/server.conf.in conf/webmail/server.conf.in
# replace webpath /cgi-bin/ by /ox/
%__subst "s|/cgi-bin/|/ox/|" groupware/DE/logout.htm groupware/EN/logout.htm templates/groupware/html/logout.htm

%__cp -f %SOURCE3 bin/groupware/
%__cp -f %SOURCE4 bin/groupware/
%__cp -f %SOURCE5 bin/webmail/
%__cp %SOURCE11 ./QUICK-START.ALT
for file in bin/groupware/openexchange-groupware.in bin/groupware/openexchange-sessiond.in bin/webmail/openexchange-webmail.in
do
	%__subst "s|@@LOGDIR@@|%_logdir/%name|" $file
	%__subst "s|@@PIDDIR@@|%_var/run/%name|" $file
	%__subst "s|@@LIBDIR@@|%_libdir/%name|" $file
	%__subst "s|@@MJ@@|%_javadir/javamail/mailapi.jar:%_javadir/javamail/pop3.jar:%_javadir/javamail/smtp.jar|" $file
done

%__tar xzf %SOURCE7

%__cp -f ox_zenith_iconset/top/* system/www/groupware/images/top/EN
%__cp -f ox_zenith_iconset/top/* system/www/groupware/images/top/DE

%build
./configure \
	--prefix=%_usr \
	--datadir=%_datadir/%name \
	--sysconfdir=%_sysconfdir/%name \
	--localstatedir=%_localstatedir/%name/ \
	--libdir=%_javadir/%name \
	--with-mailjar=%_javadir/javamail/imap.jar \
	--with-activationjar=%_javadir/activation.jar \
	--with-jdomjar=%_javadir/jdom.jar \
	--with-jsdkjar=%_javadir/servletapi5.jar \
	--with-jdbcjar=%pgjdbc \
	--with-htdocsdir=%_datadir/%name/htdocs \
	--with-cgibindir=%_datadir/%name/cgi-bin \
%if_enabled ssl
	--enable-ssl \
%endif
	--enable-webdav \
	--enable-doc \
	--with-runuid=ox \
	--with-rungid=ox

%make

%install
%make DESTDIR=%buildroot install
%__rm -rf %buildroot/%_sysconfdir/%name/init.d
%__rm -f %buildroot/%_sysconfdir/%name/initscript.conf
%__mv %buildroot/%_bindir/* %buildroot/%_sbindir/

%__mkdir_p %buildroot%_sysconfdir/{httpd/conf/addon-modules.d,httpd2/conf/addon.d}
%__mkdir_p %buildroot%_sysconfdir/rc.d/init.d
%__mkdir_p %buildroot%_logdir/%name
%__mkdir_p %buildroot%_javadocdir/%name
%__mkdir_p %buildroot%_var/run/%name
%__mkdir_p %buildroot%_localstatedir/%name/tmp
%__cp -pR %SOURCE1 %buildroot%_sysconfdir/httpd/conf/addon-modules.d/%name.conf
%__cp -pR %SOURCE1 %buildroot%_sysconfdir/httpd2/conf/addon.d/A.%name.conf
%__cp -pR %SOURCE2 %buildroot%_sysconfdir/rc.d/init.d/%name

%__subst "s|@@OX_USER@@|ox|" %buildroot%_sysconfdir/rc.d/init.d/%name
%__subst "s|@@PIDDIR@@|%_var/run/%name|" %buildroot%_sysconfdir/rc.d/init.d/%name

%__mv %buildroot/%_localstatedir/%name/log/* %buildroot/%_logdir/%name
%__rm -rf %buildroot%_localstatedir/%name/log
%__ln_s $(relative %_logdir/%name %_localstatedir/%name/log) %buildroot%_localstatedir/%name/log
%__mv %buildroot%_usr/info/java/* %buildroot%_javadocdir/%name

# make links to open-xchange jars and classes for tomcat5
%__mkdir_p %buildroot%_libdir/tomcat5/webapps/servlet/WEB-INF/{classes,lib}
for jar in comfiretools intranet nas sessiond webmail webdav umin
do
	%__ln_s $(relative %_javadir/%name/$jar.jar %_libdir/tomcat5/webapps/servlet/WEB-INF/lib/) %buildroot%_libdir/tomcat5/webapps/servlet/WEB-INF/lib/
done
%__ln_s $(relative %pgjdbc %_libdir/tomcat5/webapps/servlet/WEB-INF/lib/) %buildroot%_libdir/tomcat5/webapps/servlet/WEB-INF/lib/

for class in intranet webmail
do
	%__ln_s $(relative %_datadir/%name/servlets/$class.class %_libdir/tomcat5/webapps/servlet/WEB-INF/classes/) %buildroot%_libdir/tomcat5/webapps/servlet/WEB-INF/classes/
done

%__mkdir_p %buildroot%_libdir/tomcat5/webapps/umin
%__mv %buildroot%_javadir/%name/umin.war %buildroot%_libdir/tomcat5/webapps/umin
cd %buildroot%_libdir/tomcat5/webapps/umin
jar -xf umin.war
%__mkdir_p %buildroot%_datadir/%name/{htdocs/cfintranet/umin/,umin/data}
%__mv web/css web/images web/javascript %buildroot%_datadir/%name/htdocs/cfintranet/umin/
%__mv web/templates %buildroot%_datadir/%name/umin/data/
%__rm -rf web
%__ln_s $(relative %_datadir/%name/umin/data %_libdir/tomcat5/webapps/umin/web) %buildroot%_libdir/tomcat5/webapps/umin/web
%__mkdir_p %buildroot%_sysconfdir/%name/umin
%__mv etc/* %buildroot%_sysconfdir/%name/umin
%__rm -rf etc
%__rm -f WEB-INF/lib/*
%__mv WEB-INF/classes/* %buildroot%_sysconfdir/%name/umin
for properties in oxusermin oxusermin_de oxusermin_en oxuserminconfig
do
	%__ln_s $(relative %_sysconfdir/%name/umin/$properties.properties %_libdir/tomcat5/webapps/umin/WEB-INF/classes/) %buildroot%_libdir/tomcat5/webapps/umin/WEB-INF/classes/
done

for jar in comfiretools nas umin
do
	%__ln_s $(relative %_javadir/%name/$jar.jar %_libdir/tomcat5/webapps/umin/WEB-INF/lib/) %buildroot%_libdir/tomcat5/webapps/umin/WEB-INF/lib/
done
%__ln_s $(relative %pgjdbc %_libdir/tomcat5/webapps/umin/WEB-INF/lib/) %buildroot%_libdir/tomcat5/webapps/umin/WEB-INF/lib/

%__rm -f umin.war
%__rm -f %buildroot%_javadir/%name/servlet.war

cd $RPM_BUILD_DIR/%name-%version-%rel

# install open-xchange's xml conf file for tomcat5
%__mkdir_p %buildroot%_sysconfdir/tomcat5/Catalina/localhost
%__cp %SOURCE6 %buildroot%_sysconfdir/tomcat5/Catalina/localhost/
%__cp %SOURCE8 %buildroot%_sysconfdir/tomcat5/Catalina/localhost/

# tomcat4. Just copy from tomcat5
%__mkdir_p %buildroot%_libdir/tomcat4/webapps
%__cp -pR %buildroot%_libdir/tomcat5/webapps/* %buildroot%_libdir/tomcat4/webapps/
%__cp %SOURCE9 %buildroot%_libdir/tomcat4/webapps/%name-servlet.xml
%__cp %SOURCE10 %buildroot%_libdir/tomcat4/webapps/%name-umin.xml

# make 2 links to ldap.conf
%__ln_s $(relative %_sysconfdir/openldap/ldap.conf %_sysconfdir/%name/groupware/) %buildroot%_sysconfdir/%name/groupware/
%__ln_s $(relative %_sysconfdir/openldap/ldap.conf %_sysconfdir/%name/webmail/) %buildroot%_sysconfdir/%name/webmail/

%__install -m 644 system/servlet/web.xml %buildroot%_libdir/tomcat5/webapps/servlet/WEB-INF/

%if_enabled ssl
%__mkdir_p %buildroot%_libdir/%name
%__mv %buildroot%_javadir/%name/liboxssl.so.1.0.0 %buildroot/%_libdir/%name
%__rm -f %buildroot%_javadir/%name/liboxssl.so*
%__ln_s $(relative %_libdir/%name/liboxssl.so.1.0.0 %_libdir/%name/liboxssl.so)  %buildroot%_libdir/%name/liboxssl.so
%__ln_s $(relative %_libdir/%name/liboxssl.so.1.0.0 %_libdir/%name/liboxssl.so.1)  %buildroot%_libdir/%name/liboxssl.so.1
%endif

# RU locale
%__tar xjf %SOURCE12
%__subst "s|/cgi-bin/|/ox/|" opt/html/RU/logout.htm
%__cp -pr opt/html/* %buildroot%_datadir/%name/groupware/data/templates/
%__cp -pr opt/locales/* %buildroot%_sysconfdir/%name/groupware/locales/
%__rm -rf opt
%__tar xjf %SOURCE13
%__cp -pr opt/html/* %buildroot%_datadir/%name/webmail/data/templates/
%__cp -pr opt/locales/* %buildroot%_sysconfdir/%name/webmail/locales/

# top icons for RU locale
%__mkdir_p %buildroot%_datadir/%name/htdocs/cfintranet/images/top/RU
%__cp ox_zenith_iconset/top/* %buildroot%_datadir/%name/htdocs/cfintranet/images/top/RU/

%pre server
%_sbindir/groupadd -r -f ox >/dev/null 2>&1 ||:
%_sbindir/useradd -r -g ox -c "open-xchange server" -d %_localstatedir/%name -s /dev/null -n ox \
	>/dev/null 2>&1 ||:

%post server
%post_service %name

%preun server
%preun_service %name

%post webapp-tomcat4
/sbin/service tomcat4 condrestart

%postun webapp-tomcat4
/sbin/service tomcat4 condrestart

%post webapp-tomcat5
/sbin/service tomcat5 condrestart

%postun webapp-tomcat5
/sbin/service tomcat5 condrestart

%post apache
%_sbindir/apachectl update

%preun apache
if [ $1 = 0 ]; then
	%_sbindir/apachectl update
fi

%post apache2
%_sbindir/apachectl2 update

%preun apache2
if [ $1 = 0 ]; then
	%_sbindir/apachectl2 update
fi

%files
%doc AUTHORS CHANGES COPYING ChangeLog INSTALL NEWS README QUICK-START.ALT
%_javadir/%name
%if_enabled ssl
%_libdir/%name
%endif

%files server
%attr(0755,root,root) %_sysconfdir/rc.d/init.d/%name
%_sbindir/*
%_datadir/%name
%dir %attr(0770,root,ox) %_logdir/%name
%attr(0660,root,ox) %_logdir/%name/*
%attr(0775,root,ox) %_var/run/%name
%defattr(640,root,ox,751)
%dir %_sysconfdir/%name
%dir %_sysconfdir/%name/groupware
%dir %_sysconfdir/%name/webmail
%dir %_sysconfdir/%name/umin
%_sysconfdir/%name/webmail/locales
#%_sysconfdir/%name/groupware/CERT
%_sysconfdir/%name/groupware/METADB
%_sysconfdir/%name/groupware/locales
%_sysconfdir/%name/groupware/calendar
%_sysconfdir/%name/groupware/currencyformat
%_sysconfdir/%name/groupware/dateformat
%_sysconfdir/%name/groupware/external.conf
%_sysconfdir/%name/groupware/forum
%_sysconfdir/%name/groupware/intranet.conf
%_sysconfdir/%name/groupware/ldap.properties
%_sysconfdir/%name/groupware/nasi.conf
%_sysconfdir/%name/groupware/ldap.conf
%config(noreplace) %_sysconfdir/%name/groupware/server.conf
%_sysconfdir/%name/groupware/system.properties
%_sysconfdir/%name/groupware/tasks
%attr(640,ox,apache) %_sysconfdir/%name/umin/*.ox
%attr(640,ox,apache) %_sysconfdir/%name/umin/oxusermin.properties
%attr(640,ox,apache) %_sysconfdir/%name/umin/oxusermin_*
%_sysconfdir/%name/webmail/*.cfg
%_sysconfdir/%name/webmail/*.properties
%_sysconfdir/%name/webmail/ldap.conf
%config(noreplace) %_sysconfdir/%name/webmail/server.conf
%_sysconfdir/%name/webmail/nasi.conf
%attr(640,ox,apache) %config(noreplace) %_sysconfdir/%name/umin/oxuserminconfig.properties
%config(noreplace) %_sysconfdir/%name/admintools.conf
%defattr(660,root,ox,770)
%_localstatedir/%name

%files webapp-tomcat4
%_libdir/tomcat4/webapps/servlet
%_libdir/tomcat4/webapps/umin
%_libdir/tomcat4/webapps/%name-servlet.xml
%_libdir/tomcat4/webapps/%name-umin.xml

%files webapp-tomcat5
%_libdir/tomcat5/webapps/servlet
%_libdir/tomcat5/webapps/umin
%_sysconfdir/tomcat5/Catalina/localhost/*

%files apache
%config(noreplace) %_sysconfdir/httpd/conf/addon-modules.d/*

%files apache2
%config(noreplace) %_sysconfdir/httpd2/conf/addon.d/*

%files javadoc
%_javadocdir/%name

%changelog
* Tue Jun 14 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1.3
- 0.8.0-3
- updated russian translation

* Mon May 16 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1.2
- 0.8.0-2
- updated russian groupware translation, added webmail translation
  (Alex <exilit at nm.ru>

* Sat May 07 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1.1
- 0.8.0-1
- added russian translation for groupware ( thanx 2 Alex <exilit at nm.ru> )

* Wed Apr 27 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1
- 0.8.0
- added support for apache2 and tomcat4
- use postgresql74-jdbc

* Thu Apr 14 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt0.1.RC1
- Initial release for ALT Linux Sisyphus


